<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>LibGE: src/AGContext.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="cropped-BDS-Logo-1.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibGE
   &#160;<span id="projectnumber">0.31.0</span>
   </div>
   <div id="projectbrief">A c++ GE implementation</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">AGContext.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_a_g_context_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// AGContext.h -*- C++ -*-</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef _AGCONTEXT_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define _AGCONTEXT_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">/* This class defines the context of an AGSymbol object while expanding a tree */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">/* of type AGDerivationTree. When calling the updateInheritedAttributes()      */</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* method of an AGSymbol object, the &#39;startIndex&#39; points to the leftmost sibl- */</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">/* ing of the AGSymbol object in the same subtree, whereas the &#39;endIndex&#39;      */</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">/* points to the AGSymbol object itself. &#39;parent&#39; points to the parent node of */</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">/* the AGSymbol object.                                */</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">/*                                                                             */</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">/* When calling the updateSynthsisedAttributes() method of an AGSymbol object  */</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">/* the context should contain information on all the child nodes. Thus,        */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">/* &#39;startIndex&#39; points to the left most child, and &#39;endIndex&#39; points to the end*/</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">/* of the iterator. Note, in this case endIndex=it.end() where &#39;it&#39; is an iter-*/</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">/* ator of type AGTree::iterator; &#39;endIndex&#39; does NOT point to the last child. */</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">/* &#39;parent&#39; points to the parent node of the AGSymbol object.              */</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">/*                                         */</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">/* GEGrammar::buildAGTree method contains the code to update AGContext object. */</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="lib_g_edefs_8h.html">libGEdefs.h</a>&quot;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_a_g_derivation_tree_8h.html">AGDerivationTree.h</a>&quot;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">using namespace </span>std;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="class_a_g_context.html">   28</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_a_g_context.html">AGContext</a> {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="keyword">public</span>: </div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <a class="code" href="class_a_g_context.html">AGContext</a>();</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;                <a class="code" href="class_a_g_context.html">AGContext</a>(<a class="code" href="class_tree.html">AGTree</a>*, AGTree::iterator, AGTree::iterator);</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;                <span class="keyword">virtual</span> ~<a class="code" href="class_a_g_context.html">AGContext</a>();</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;                <a class="code" href="class_tree.html">AGTree</a>* getParent() <span class="keyword">const</span>;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;                <span class="keywordtype">void</span> setParent(<a class="code" href="class_tree.html">AGTree</a>* p);</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;                AGTree::iterator getStartIndex() <span class="keyword">const</span>;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;                <span class="keywordtype">void</span> setStartIndex(AGTree::iterator); </div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;                AGTree::iterator getEndIndex() <span class="keyword">const</span>;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;                <span class="keywordtype">void</span> setEndIndex(AGTree::iterator);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keyword">protected</span>:</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="class_a_g_context.html#a884ed4f87e757bf4f46a74631e188935">   40</a></span>&#160;                  <a class="code" href="class_tree.html">AGTree</a>* <a class="code" href="class_a_g_context.html#a884ed4f87e757bf4f46a74631e188935">parent</a>; </div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="class_a_g_context.html#ae2f5cc059dafd9d90146007c7ccb335c">   41</a></span>&#160;                  AGTree::iterator  <a class="code" href="class_a_g_context.html#ae2f5cc059dafd9d90146007c7ccb335c">startIndex</a>;</div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="class_a_g_context.html#a6e8d750c8d0cf17992829a5b3bb8a813">   42</a></span>&#160;                  AGTree::iterator  <a class="code" href="class_a_g_context.html#a6e8d750c8d0cf17992829a5b3bb8a813">endIndex</a>;         </div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;};</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#endif</span></div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclass_a_g_context_html_a884ed4f87e757bf4f46a74631e188935"><div class="ttname"><a href="class_a_g_context.html#a884ed4f87e757bf4f46a74631e188935">AGContext::parent</a></div><div class="ttdeci">AGTree * parent</div><div class="ttdef"><b>Definition:</b> AGContext.h:40</div></div>
<div class="ttc" id="aclass_a_g_context_html_a6e8d750c8d0cf17992829a5b3bb8a813"><div class="ttname"><a href="class_a_g_context.html#a6e8d750c8d0cf17992829a5b3bb8a813">AGContext::endIndex</a></div><div class="ttdeci">AGTree::iterator endIndex</div><div class="ttdef"><b>Definition:</b> AGContext.h:42</div></div>
<div class="ttc" id="a_a_g_derivation_tree_8h_html"><div class="ttname"><a href="_a_g_derivation_tree_8h.html">AGDerivationTree.h</a></div></div>
<div class="ttc" id="alib_g_edefs_8h_html"><div class="ttname"><a href="lib_g_edefs_8h.html">libGEdefs.h</a></div></div>
<div class="ttc" id="aclass_a_g_context_html_ae2f5cc059dafd9d90146007c7ccb335c"><div class="ttname"><a href="class_a_g_context.html#ae2f5cc059dafd9d90146007c7ccb335c">AGContext::startIndex</a></div><div class="ttdeci">AGTree::iterator startIndex</div><div class="ttdef"><b>Definition:</b> AGContext.h:41</div></div>
<div class="ttc" id="aclass_tree_html"><div class="ttname"><a href="class_tree.html">Tree</a></div><div class="ttdef"><b>Definition:</b> Tree.h:17</div></div>
<div class="ttc" id="aclass_a_g_context_html"><div class="ttname"><a href="class_a_g_context.html">AGContext</a></div><div class="ttdef"><b>Definition:</b> AGContext.h:28</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
